'QBASIC VRCVI Register to RAW converter.  It produces an 8 bit non-signed
'44.1Khz RAW stream.  Use Goldwave or similar to listen or convert
'to WAV.  Note that this is a 6 bit audio signal and 2 bits aren't
'used (though I did add 96 to it to centre it on the waveform screen)
'Thanks to TNSE^1999 for giving me the register dump.
'Written by Kevin Horton, 8/31/99

DEFDBL N
DECLARE FUNCTION sqr1 (reg9000, reg9001, reg9002)
DECLARE FUNCTION sqr2 (rega000, rega001, rega002)
DECLARE FUNCTION saw1 (regb000, regb001, regb002)
DECLARE FUNCTION hex2dec (ins$)


DIM r900(2)
DIM ra00(2)
DIM rb00(2)

CLS


OPEN "dejavu.txt" FOR INPUT AS 1
OPEN "wavout.raw" FOR OUTPUT AS 2

'44100hz wav file
nestimebase = 3579545.45454545# / 2
numcycnes = nestimebase / 60
numcycwav = 44100 / 60
nesincsize = numcycnes / numcycwav

PRINT nesincsize
sqr1phaseacc = 0
sqr2phaseacc = 0
saw1phaseacc = 0

PRINT "Number of WAV samples per NES frame:    "; numcycwav
PRINT "Number of counter cycles per NES frame: "; numcycnes

WHILE NOT EOF(1)
WHILE LEFT$(dumpline$, 5) <> "Frame" AND NOT EOF(1)
INPUT #1, dumpline$
IF LEFT$(dumpline$, 5) <> "Write" THEN GOTO nowr
chan$ = MID$(dumpline$, 9, 1)
reg = VAL(MID$(dumpline$, 12, 1))
valu = hex2dec(MID$(dumpline$, 14, 2))
IF chan$ = "9" THEN r900(reg) = valu
IF chan$ = "A" THEN ra00(reg) = valu
IF chan$ = "B" THEN rb00(reg) = valu
nowr:
WEND
dumpline$ = ""
PRINT r900(0), r900(1), r900(2)

FOR a = 1 TO numcycwav
outval = sqr1(r900(0), r900(1), r900(2))
outval = outval + sqr2(ra00(0), ra00(1), ra00(2))
outval = outval + saw1(rb00(0), rb00(1), rb00(2))

PRINT #2, CHR$(96 + outval);
NEXT

WEND

FUNCTION hex2dec (ins$)
x$ = "0123456789ABCDEF"
FOR i1 = 1 TO 16
IF MID$(x$, i1, 1) = LEFT$(ins$, 1) THEN xc = (i1 - 1) * 16
NEXT
FOR i1 = 1 TO 16
IF MID$(x$, i1, 1) = RIGHT$(ins$, 1) THEN xc = xc + (i1 - 1)
NEXT
hex2dec = xc
END FUNCTION

FUNCTION saw1 (regb000, regb001, regb002)
SHARED numcycnes 'number of cycles of the WAV per frame
SHARED numcycwav 'number of cycles of the counter clock per frame
SHARED nestimebase 'number of cycles per second
SHARED saw1phaseacc ' square 1's phase accumulator
SHARED nesincsize   '# of nes cycles per WAV cycle
SHARED phaseacc
SHARED b3

'regb000: 0-5=phase accumulator bits
'regb001: 8 bits of freq
'regb002: 0-3=high freq, 7=enable

'# of cycles

freq3 = (regb001 + ((regb002 AND 15) * 256) + 1)
saw1phaseacc = saw1phaseacc - nesincsize '# of clocks per wav cycle
IF saw1phaseacc < 0 THEN saw1phaseacc = saw1phaseacc + (freq3 * 2): ptrig = 1
IF ptrig = 1 THEN phaseacc = phaseacc + (regb000 AND &H3F)
IF ptrig = 1 THEN b3 = b3 + 1: IF b3 = 7 THEN b3 = 0: phaseacc = 0
ptrig = 0

saw1 = ((phaseacc \ 8) AND &H1F) * (regb002 \ 128)

END FUNCTION

FUNCTION sqr1 (reg9000, reg9001, reg9002)
SHARED numcycnes 'number of cycles of the WAV per frame
SHARED numcycwav 'number of cycles of the counter clock per frame
SHARED nestimebase 'number of cycles per second
SHARED sqr1phaseacc ' square 1's phase accumulator
SHARED nesincsize   '# of nes cycles per WAV cycle
SHARED b1

'reg9000: 0-3=volume, 4-6=duty cycle
'reg9001: 8 bits of freq
'reg9002: 0-3=high freq, 7=enable

'# of cycles

freq1 = (reg9001 + ((reg9002 AND 15) * 256) + 1)
sqr1phaseacc = sqr1phaseacc - nesincsize '# of clocks per wav cycle
IF sqr1phaseacc < 0 THEN sqr1phaseacc = sqr1phaseacc + freq1: b1 = (b1 + 1) AND 15
IF b1 < ((reg9000 \ 16) + 1) THEN bit1 = 1 ELSE bit1 = 0

sqr1 = (reg9000 AND 15) * (reg9002 \ 128) * bit1 * 2
END FUNCTION

FUNCTION sqr2 (rega000, rega001, rega002)
SHARED numcycnes 'number of cycles of the WAV per frame
SHARED numcycwav 'number of cycles of the counter clock per frame
SHARED nestimebase 'number of cycles per second
SHARED sqr2phaseacc ' square 1's phase accumulator
SHARED nesincsize   '# of nes cycles per WAV cycle
SHARED b2

'rega000: 0-3=volume, 4-6=duty cycle
'rega001: 8 bits of freq
'rega002: 0-3=high freq, 7=enable

'# of cycles

freq2 = (rega001 + ((rega002 AND 15) * 256) + 1)
sqr2phaseacc = sqr2phaseacc - nesincsize '# of clocks per wav cycle
IF sqr2phaseacc < 0 THEN sqr2phaseacc = sqr2phaseacc + freq2: b2 = (b2 + 1) AND 15
IF b2 < ((rega000 \ 16) + 1) THEN bit2 = 1 ELSE bit2 = 0

sqr2 = (rega000 AND 15) * (rega002 \ 128) * bit2 * 2

END FUNCTION

